﻿#!/usr/bin/env python
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to:
#     The Free Software Foundation, Inc.,
#     51 Franklin Street, Fifth Floor
#     Boston, MA  02110-1301, USA.
#
#The licensing nature of this d3vscan is subject to change solely by the author upon the next release
#
# Author: Devtar Singh <devtar@gmail.com>
# Text Encoding: UTF-8

import __main__
import bluetooth
import string

try:
 	import pygtk
  	pygtk.require("2.0")
except:
  	pass
try:
	import gtk
  	import gtk.glade
except:
	print "Essential GTK Glade libraries not found!"
	sys.exit(1)

#bluetooth class
class bt:
	 def __init__(self, main):
		#when bluetooth mode selected
		 #clear list
		 endread = False
		 endsearch = False
		 btbuf1 = ""
		 btbuf2 = ""
		 btnamesearch = [ "" ]
		 btmacsearch = [ "" ]
		 __main__.btname = [ "" ]
		 __main__.btmac = [ "" ]
		 __main__.sdpinfo = [ "" ]
		 print 'Bluetooth mode'
		 #Bluetooth Mode
		 count = 0
		 buffer = ""
		 #clear bt lists
		 while ((len(__main__.btname)-1) > count):
			 __main__.btname.pop()
			 __main__.btmac.pop()
			 __main__.sdpinfo.pop()
		 #scan
		 btdevices = bluetooth.discover_devices(lookup_names = True)
		 progress("Start")
		 main.textview.get_buffer().set_text('Devices Found:\n')				 
		 for addr, name in btdevices:		     
			 if (name == ""):
				 name = "N/A"
			 __main__.btname.append(name)
			 __main__.btmac.append(addr)
			 #string formatting \ remove newline
			 name = string.replace(name, "\n", "")		     			 
			 addr = string.replace(addr, "\n", "")
		 
		 #Bluetooth Manifacturer identification [note:consider loading btmacsearch buffer into memory for faster scanning ]		 		 	 
		 while ((len(__main__.btname)-1) > count):
			 count+= 1
			 count2 = 0
			 endsearch = False
			 inFile3 = open("btdb.dat", "rb")
			 for line3 in inFile3:
				 #line3 = string.replace(line3, '\n', "")
				 count2+=1
				 if(endread == False):
					 btbuf1, btbuf2 = line3.split(";")
					 btmacsearch.append(btbuf1)
					 btnamesearch.append(btbuf2)
				 if( __main__.btmac[count][:8] == btmacsearch[count2]):
					 __main__.btmanu.append(btnamesearch[count2])
					 endsearch = True
			 endread = True
			 print "Status : " + str(endsearch)
			 if(endsearch == False):
				 print "Null: " + __main__.btmac[count][:8]
				 __main__.btmanu.append("null")
			 inFile3.close()		 
		 
		 count = 0
		 print "MANU : " + str(len(__main__.btmanu)) + "\nBTname : " + str(len(__main__.btname))
		 while (len(__main__.btname)-1) > count:		     
			 count+=1
			 print "\nDevice "+str(count)+"\n  Device Name: "+__main__.btname[count]+"\n  Device Address: "+__main__.btmac[count]+"\n  Device Manufacturer: "+__main__.btmanu[count]
			 main.textview.get_buffer().insert_at_cursor("\nDevice "+str(count)+"\n  Device Name: "+__main__.btname[count]+"\n  Device Address: "+__main__.btmac[count]+"\n  Device Manufacturer: "+__main__.btmanu[count])

		 # Progress Bar Work
		 main.progressbar.set_text("100%")
		 main.progressbar.set_fraction(1)
		 context_id = main.statusbar.get_context_id("scan2")
		 main.statusbar.push(context_id, "Bluetooth Scan Completed")
	 
class sdp:
	 #SDP Browse List View
     def __init__(self,main,myiter,count):		 
		 syscallIter=main.listmodel.append(myiter,(None,"SDP Browse"))
		 print "SDP : " + str(__main__.btmac[count])
		 sdpservices=bluetooth.find_service(address=__main__.btmac[count])		 
		 print "SDP Service:" + str(len(sdpservices)) 
		 if len(sdpservices) > 0:
			 cntbuf = "found " + str(len(sdpservices)) + " services"
			 main.listmodel.append( syscallIter,["", cntbuf ])
			 for svc in sdpservices:
				 sdpbrowseinfo = "\nService Name: " + str(svc["name"]) + "\n Description: " + str(svc["description"]) + "\n Provided By: " + str(svc["provider"]) + "\n Protocol: " + str(svc["protocol"]) + "\n channel/PSM: " + str(svc["port"]) + "\n svc classes: " + str(svc["service-classes"]) + "\n profiles:  " + str(svc["profiles"]) + "\n service id: " + str(svc["service-id"])					 			     				 
				 print sdpbrowseinfo
				 main.listmodel.append( syscallIter,["", sdpbrowseinfo])
		 else:
			 sdpbrowseinfo = "no services found"
			 main.listmodel.append( syscallIter,["", sdpbrowseinfo])
			 
class progress:
     def __init__(self, PROGSTATUS):
		 if (PROGSTATUS == "START"):		     
			 i=0
			 n=1000
			 main.progressbar.set_orientation(gtk.PROGRESS_LEFT_TO_RIGHT)
			 while i < n:
			     sleep(0.0006)
			     main.progressbar.set_fraction(i/(n-1.0))
			     main.progressbar.set_text(str(i/10))
			     i += 1
			     while gtk.events_pending():
		  	         gtk.main_iteration(False)
		 elif (PROGSTATUS=="STOP"):		     
			 main.progressbar.set_orientation(gtk.PROGRESS_RIGHT_TO_LEFT)
			 main.progressbar.set_fraction(0)
			 main.progressbar.set_text("")
